/*********************************************************************
机器人基地 RobotBase www.robotbase.cn       	
		                                                            
目    的:   超声波测距仪
		
目标系统:   基于Arduino Duemilanove控制器

应用软件:   Arduino 0017                                               
		                                                                                                                        
发布时间:   2010-02-23

说    明:   若用于商业用途，请保留此段文字或注明代码来源
		
	        哈尔滨奥松机器人科技有限公司保留所有版权   
*********************************************************************/
#include <LCD4Bit_mod.h> 
LCD4Bit_mod lcd = LCD4Bit_mod(2); 
int inputPin=2;  // 定义超声波信号接收接口
int outputPin=3; // 定义超声波信号发出接口
void setup() { 
  pinMode(inputPin, INPUT);
  pinMode(outputPin, OUTPUT);
  lcd.init();
  lcd.clear();
  lcd.printIn("    Welcome to   ");
  lcd.cursorTo(2, 0);
  lcd.printIn("www.robotbase.cn");
  delay(3000);
  lcd.cursorTo(1, 0);
  lcd.printIn("www.robotbase.cn");
  lcd.cursorTo(2, 0);
  lcd.printIn("There's no echo.");
}
void loop() {
  digitalWrite(outputPin, LOW); // 使发出发出超声波信号接口低电平2μs
  delayMicroseconds(2);
  digitalWrite(outputPin, HIGH); // 使发出发出超声波信号接口高电平10μs，这里是至少10μs
  delayMicroseconds(10);
  digitalWrite(outputPin, LOW);    // 保持发出超声波信号接口低电平
  float distance = pulseIn(inputPin, HIGH);  // 读出脉冲时间
  distance= distance/5.8;   // 将脉冲时间转化为距离（单位：毫米）
  lcd.cursorTo(2, 0);  //line=2, x=0
  lcd.printIn("Distance:");//输出距离值
  display(distance,0x49);//显示距离
}
void display(int number,unsigned char address)//显示数字
{
  unsigned char b,c,d,e;
  b=(number/1000);
  c=(number/100)%10;
  d=(number/10)%10;
  e=number%10;
  lcd.commandWrite(0x80+address);
  lcd.print(b+48);
  lcd.print(c+48);
  lcd.print(d+48);
  lcd.print(46);
  lcd.print(e+48);
  lcd.print(99);//"c"的ASCII
  lcd.print(109);//"m"的ASCII
}
