#include "ST7920.h"
extern "C" {
	#include <stdio.h>  //not needed yet
	#include <string.h> //needed for strlen()
	#include <inttypes.h>
	#include <stdlib.h>
	#include <math.h>
	#include <avr/pgmspace.h>
	#include "WConstants.h"  //all things wiring / arduino
}

int SID = 4;
int SCK = 3;

void ST7920::LCD_SendByte(unsigned char a)
{
	unsigned char i,d;
	pinMode(SID, OUTPUT);
	for(i=0;i<8;i++)
	{
		digitalWrite(SCK, LOW);   
		d = a&0x80;
		if(d)
			digitalWrite(SID, HIGH);
		else
			digitalWrite(SID, LOW);
		a<<=1;
		digitalWrite(SCK, HIGH);
	}
}
/******************************************************************************************
*     ReceiveByte
*     ڽһֽ
*          ƣ /    
* ڶȡݵʱõ
* һֻܶ4bit
* ֵ      
*         
*     2006-12-19
* ȫֱ    
* ȫ־̬
* ֲ̬
*----------------------------------------޸ʷ------------------------------------------
* ǰ汾         ޸ˣ                  ޸ڣ
* ޸˵    
******************************************************************************************/
unsigned char ST7920::ReceiveByte(void)
{
	pinMode(SID, INPUT);
     unsigned char i,temp1,temp2;
     temp1 = 0;
     temp2 = 0;
     for(i=0;i<8;i++)
     {
           temp1=temp1<<1;
           digitalWrite(SCK, LOW);
           digitalWrite(SCK, HIGH);            
           digitalWrite(SCK, LOW);
           if(digitalRead(SID)) temp1++;
     }
     for(i=0;i<8;i++)
     {
           temp2=temp2<<1;
           digitalWrite(SCK, LOW);
           digitalWrite(SCK, HIGH);
           digitalWrite(SCK, LOW);
           if(digitalRead(SID)) temp2++;
     }
	 delay(1);
     return ((0xf0&temp1)+(0x0f&temp2));
	 pinMode(SID,OUTPUT);
}
/******************************************************************************************
*     CheckBusy
*     
*          ƣ /    
******************************************************************************************/
void ST7920::LCD_CheckBusy(void)
{
     do   LCD_SendByte(0xfc);      //11111,RW(1),RS(0),0
     while(0x80&ReceiveByte());      //BF(.7)=1 Busy
}
//************************************************************************************
//*:void ST7920::LCD_Write(unsigned char Data_Command , unsigned char uc_Content ) *
//*:ģʽLCDݻָ												 *
//*ʽ:unsigned char Data_Command , unsigned char uc_Content					 *
//*β˵:ݻָı־λ,ָݵ										 *
//*ز:																		 *
//*ʹ˵:																		 *
//************************************************************************************
void ST7920::LCD_Write( unsigned char Data_Command , unsigned char uc_Content )
{ 
	unsigned char temp;
	delay(2);
	LCD_CheckBusy();
	
	if(Data_Command)
	{
		temp = 0xFA;	//RS = 1,; RW = 0,дģʽ
	}
	else 
	{
		temp = 0xF8;	//RS = 0,ָ; RW = 0,дģʽ
	}
	LCD_SendByte(temp);

	temp = uc_Content&0xF0;
	LCD_SendByte(temp);

	temp = (uc_Content<<4)&0xF0;
	LCD_SendByte(temp);
}

/******************************************************************************************
*     ReadData
*     
*          ƣ /    
******************************************************************************************/
unsigned char ST7920::LCD_ReadData(void)
{
     LCD_CheckBusy();
     LCD_SendByte(0xfe);            //11111,RW(1),RS(1),0
     return ReceiveByte();
}

//*************************************************************
//*:void ST7920::LCD_DDRAM_AddressSet(unsigned char ucDDramAdd) *
//*:趨DDRAM(ı)ַַAC				  *
//*ʽ:unsigned char ucDDramAdd								  *
//*в˵:ַ										  *
//*ʽ˵:												  *
//*		RS	RW	DB7	DB6	DB5	DB4	DB3	DB2	DB1	DB0				  *
//*		0	0	1	AC6	AC5	AC4	AC3	AC2	AC1	AC0				  *
//*ز:												  *
//*ʹ˵:												  *
//*	һеַ:80H~8FH										  *
//*	ڶеַ:90H~9FH										  *
//*	еַ:A0H~AFH										  *
//*	еַ:B0H~BFH										  *
//*************************************************************
void ST7920::LCD_DDRAM_AddressSet(unsigned char ucDDramAdd)
{
	LCD_Write(LCD_COMMAND,LCD_BASIC_FUNCTION);			//ָ
	LCD_Write(LCD_COMMAND,ucDDramAdd);				//趨DDRAMַַAC
}

//*************************************************************
//*:void ST7920::LCD_CGRAM_AddressSet(unsigned char ucCGramAdd) *
//*:趨CGRAM(Զֿ)ַַAC		  *
//*ʽ:unsigned char ucCGramAdd								  *
//*β˵:ַ										  *
//*ʽ˵:												  *
//*		RS	RW	DB7	DB6	DB5	DB4	DB3	DB2	DB1	DB0				  *
//*		0	0	0	1	AC5	AC4	AC3	AC2	AC1	AC0				  *
//*ز:												  *
//*ʹ˵:ַΧΪ40H~3FH								  *
//*************************************************************
void ST7920::LCD_CGRAM_AddressSet(unsigned char ucCGramAdd)
{
	LCD_Write(LCD_COMMAND,LCD_BASIC_FUNCTION);			//ָ
	LCD_Write(LCD_COMMAND,ucCGramAdd);				//趨CGRAMַַAC
}

//*******************************************************************************
//*:void ST7920::LCD_GDRAM_AddressSet(unsigned char ucGDramAdd)         *
//*:趨GDRAM(ͼ)ַַAC                                 *
//*ʽ:unsigned char ucGDramAdd                                            *
//*β˵:ֵַ                                                          *
//*		RS	RW	DB7	DB6	DB5	DB4	DB3	DB2	DB1	DB0                                 *
//*		0	0	1	AC6	AC5	AC4	AC3	AC2	AC1	AC0                                 *
//*		趨ֱλ趨ˮƽλ(дֽɴֱˮƽλõ)  *	
//*		ֱַΧ:AC6~AC0                                                    *
//*		ˮƽַΧ:AC3~AC0                                                    *
//*ز:                                                                  *
//*ʹ˵:չָʹ                                        *
//*******************************************************************************
void ST7920::LCD_GDRAM_AddressSet(unsigned char ucGDramAdd)
{
	LCD_Write(LCD_COMMAND,LCD_EXTEND_FUNCTION);			//չָ
	LCD_Write(LCD_COMMAND,ucGDramAdd);		
}

//*******************************************
//*:void ST7920::LCD_Init(void)	*
//*:гʼLCD					*
//*ʽ:								*
//*β˵:								*
//*ز:								*
//*ʹ˵:								*
//*******************************************
void ST7920::LCD_Init(void)
{
	pinMode(SID,OUTPUT);
	pinMode(SCK,OUTPUT);
	delay(100);
  	LCD_Write(LCD_COMMAND,LCD_BASIC_FUNCTION); //ָ   
  	LCD_Write(LCD_COMMAND,LCD_CLEAR_SCREEN);  	//ַָָ00H
  	LCD_Write(LCD_COMMAND,0x06);  		    //ƶ
  	LCD_Write(LCD_COMMAND,0x0C);  			//ʾα
}

//********************************************************
//*:void ST7920::LCD_ClearRam(void)	             *
//*:					             *
//*ʽ:								             *
//*β˵:							     	         *
//*ز:								             *
//*ʹ˵:DDRAM20H,趨DDRAM AC00H	         *
//*ʽ˵:											 *
//*		    RS	RW	DB7	 DB6  DB5  DB4	DB3	DB2	DB1	DB0	 *
//*		    0	0	 0	  0	   0	0	 0   0	 0	 1	 *
//********************************************************
void ST7920::LCD_ClearRam(void)
{
	LCD_Write(LCD_COMMAND,LCD_BASIC_FUNCTION);			//ָ
	LCD_Write(LCD_COMMAND,LCD_CLEAR_SCREEN);			//
}

//**********************************************************
//:Overturn_Char(unsigned char x,unsigned char y,unsigned char cor)
//:ʹûͼķһ16*8ַ
//ʽ:uunsigned char x,unsigned char y,unsigned char wide,unsigned char cor
//			xȡֵΧ:1~16
//			yȡֵΧ:1~4
//          wideȡֵΧ:1~16
//в˵:ˮƽλ,괹ֱλ,,Ҫ׻(1:,2:)
//Һ˵:
//		_______________128______________________
//		|(1,1)								    (16,1)|	
//		|											  |	
//	6	|											  |	
//	4	|									          |
//		|          									  |	
//		|											  |	
//		|											  |
//		|(1,4)__________________________________(16,4)|
//
//ز:
//ʹ˵:
//**********************************************************
void ST7920::Overturn_Char(unsigned char x,unsigned char y,unsigned char wide,unsigned char cor)
{
    unsigned char i,base_x,colour;
	if(cor == 1) colour = 0xFF;
	if(cor == 0) colour = 0x00;
	LCD_GraphModeSet(0x00);;
	if(y == 1 || y == 2)    base_x = 0x80;
	if(y == 3 || y == 4)    base_x = 0x88;
    if(x % 2)
	{
	    for(i = 0;i < wide; i ++)
		{
	        LCD_Write(LCD_COMMAND,0X80 - 16 + y * 16 + i);
	        LCD_Write(LCD_COMMAND,base_x+(x/2)); 
		    LCD_Write(LCD_DATA,colour);
		    LCD_Write(LCD_DATA,0x00);
		}
	}
	else
	{
	    for(i = 0;i < wide; i ++)
		{
	        LCD_Write(LCD_COMMAND,0X80 - 16 + y * 16 + i);
	        LCD_Write(LCD_COMMAND,base_x+(x/2)-1); 
		    LCD_Write(LCD_DATA,0x00);
		    LCD_Write(LCD_DATA,colour);
		}
	}	
	LCD_GraphModeSet(0x01);		
}


//**********************************************************
//:Overturn_Font(unsigned char x,unsigned char y,unsigned char wide,unsigned char cor)
//:ʹûͼķһ16*16ĺַ
//ʽ:uunsigned char x,unsigned char y,unsigned char wide,unsigned char cor
//			xȡֵΧ:1~8
//			yȡֵΧ:1~4
//          wideȡֵΧ:1~16
//в˵:ˮƽλ,괹ֱλ,,Ҫ׻(1:,2:)
//Һ˵:
//		_______________128______________________
//		|(1,1)								     (8,1)|	
//		|											  |	
//	6	|											  |	
//	4	|									          |
//		|          									  |	
//		|											  |	
//		|											  |
//		|(1,4)___________________________________(8,4)|
//
//ز:
//ʹ˵:
//**********************************************************
void ST7920::Overturn_Font(unsigned char x,unsigned char y,unsigned char wide,unsigned char cor)
{
    unsigned char i,base_x,colour;
	if(cor == 1) colour = 0xFF;
	if(cor == 0) colour = 0x00;
	LCD_GraphModeSet(0x00);;
	if(y == 1 || y == 2)    base_x = 0x80;
	if(y == 3 || y == 4)    base_x = 0x88;
	
    for(i = 0;i < wide;i ++)
	{
	    LCD_Write(LCD_COMMAND,0X80 - 16 + y * 16 + i); //- 16 + y * 16 + i);
	    LCD_Write(LCD_COMMAND,base_x+x-1); 
		LCD_Write(LCD_DATA,colour);
		LCD_Write(LCD_DATA,colour);
	}
	LCD_GraphModeSet(0x01);;
}
void ST7920::chsDisplay_8bit(unsigned char ucAdd, unsigned char code)
{
	LCD_Write(LCD_COMMAND,LCD_BASIC_FUNCTION);  			//ָ   
	LCD_DDRAM_AddressSet(ucAdd);
	LCD_Write(LCD_DATA, code);
}
void ST7920::chsDisplay_16bit(unsigned char ucAdd, unsigned int code)
{
	LCD_Write(LCD_COMMAND,LCD_BASIC_FUNCTION);  			//ָ   
	LCD_DDRAM_AddressSet(ucAdd);
	unsigned char temp;
	delay(2);
	temp = 0xFA;	//RS = 1,; RW = 0,дģʽ
	LCD_SendByte(temp);

	temp = (code&0xF000)>>8;
	LCD_SendByte(temp);

	temp = (code&0x0F00)>>4;
	LCD_SendByte(temp);
	
	temp = code&0x00F0;
	LCD_SendByte(temp);
	
	temp = (code&0x000F)<<4;
	LCD_SendByte(temp);
}

//*********************************************************************************
//*:void ST7920::LCD_DisplayStrings_WithAddress(unsigned char ucAdd,unsigned char code *p)	  *
//*:(ı)ucAddָλʾһַ(ǺֻASCII߻)  *
//*ʽ:unsigned char ucAdd,unsigned char code *p							  *
//*β˵:ָλ,Ҫʾַ											  *
//*ַ:80H~87H,90H~97H,88H~8FH,98H~8FH									  *
//*ز:																	  *
//*ʹ˵:ʹ֮ǰҪʼҺ												  *
//*********************************************************************************
void ST7920::LCD_DisplayStrings_WithAddress(unsigned char ucAdd,const char *p)
{
	unsigned char length;
	length = strlen(p);
    LCD_Write(LCD_COMMAND,LCD_BASIC_FUNCTION);  			//ָ   
	LCD_DDRAM_AddressSet(ucAdd);
	for( ;  length ; length -- )
		LCD_Write(LCD_DATA, *(p++));					
}
void ST7920::LCD_DisplayMatrix_WithAddress(unsigned char ucAdd,unsigned char *p)
{
    LCD_Write(LCD_COMMAND,LCD_BASIC_FUNCTION);  			//ָ   
	LCD_DDRAM_AddressSet(ucAdd);
	while(*p)
		LCD_Write(LCD_DATA, *(p++));					
}
//*********************************************************************************
//*:void ST7920::LCD_DisplayStrings(unsigned char x,unsigned char y,unsigned char code *p)	  *
//*:(ı)ucAddָλʾһASCII                                *
//*ʽ:unsigned char x,unsigned char y,const char *p						  *
//*β˵:ָλ,Ҫʾַ											  *
//*ַ: x<16, y<4			                       						  *
//*ز:																	  *
//*ʹ˵:ʹ֮ǰҪʼҺ												  *
//*********************************************************************************
void ST7920::LCD_DisplayStrings(unsigned char x,unsigned char y,const char *p)
{
	unsigned char length,addr=0;
	unsigned char AddrEO;	//xַż
	unsigned char Data1;

	y &= 0x03;	//y < 4
	x &= 0x0F;	//x < 16

	switch( y )
	{
		case 0:
			addr = 0x80;
		break;

		case 1:
			addr = 0x90;
		break;

		case 2:
			addr = 0x88;
		break;

		case 3:
			addr = 0x98;
		break;
	}

	addr += x/2;
	AddrEO = x&0x01;

	length = strlen(p);

	LCD_Write(LCD_COMMAND,LCD_BASIC_FUNCTION);  			//ָ   
	LCD_DDRAM_AddressSet(addr);

	if(AddrEO == 0x01)
		{
		Data1 = LCD_ReadData();
		LCD_DDRAM_AddressSet(addr);
		LCD_Write(LCD_DATA, Data1);
		}

	for( ;  length ; length -- )
		LCD_Write(LCD_DATA, *(p++));
}
/*****************************************************
//*:void ST7920::LCD_GraphModeSet(unsigned char bSelect) *
//*:򿪻رջͼʾ						  *
//*ʽ:unsigned char Select					  *
//*β˵:򿪻رջͼʾı־λ,1,0ر	  *
//*ʽ˵:										  *
//*		RS	RW	DB7	DB6	DB5	DB4	DB3	DB2	DB1	DB0		  *
//*		0	0	0	0	1	1	X	RE	 G	 X		  *
//*		                    						  *
//*		RE:0,ָ								  *
//*		RE:1,ָ								  *
//*		G :0,ͼʾOFF							  *
//*		G :1,ͼʾON								  *
//*ز:										  *
//*ʹ˵:										  *
//*****************************************************/
void ST7920::LCD_GraphModeSet(unsigned char Select)
{
	LCD_Write(LCD_COMMAND,LCD_EXTEND_FUNCTION);	//չָ
	if(Select)
	{
		LCD_Write(LCD_COMMAND,LCD_GRAPH_ON);		//򿪻ͼģʽ
	}
	else
	{
		LCD_Write(LCD_COMMAND,LCD_GRAPH_OFF);		//رջͼģʽ	
	}
}
//*********************************************************************
//*:void ST7920::LCD_ImgDisplay(unsigned char code *img)              *
//*:ȫʾ128*64صͼ                                *
//*ʽ:unsigned char code *img                                   *
//*β˵:Ҫʾͼ                                              *
//*Һ˵:                                                    *
//*      ________________128______________________              *
//*      |(0,0)                                    (7,0)|             *
//*      |                                              |             *
//*   64 |                                              |             *
//*    |(0,31)                                  (7,31)|             *
//*    |(8,0)                                   (15,0)|             *
//*    |                                              |             *
//*      |                                              |             *
//*      |(8,31)                                 (15,31)|             *
//*      |______________________________________________|             *
//*                                                                   *
//ز:                                                         *
//ʹ˵:˺CM12864-12Һ                               *
//*********************************************************************/
void ST7920::LCD_ImgDisplay(unsigned char *img)
{
  	unsigned char i,j;
    LCD_GraphModeSet(0x00); //ȹرͼʾ
	for(j=0;j<32;j++)
  	 {
    	for(i=0;i<8;i++)
     	 {
      		LCD_Write(LCD_COMMAND,0x80+j);		//趨ֱ
      		LCD_Write(LCD_COMMAND,0x80+i);		//趨ˮƽ
      	    LCD_Write(LCD_DATA,img[j*16+i*2]);	//ݸֽ
      		LCD_Write(LCD_DATA,img[j*16+i*2+1]);	//ݵֽ
    	 }
  	 }
  	for(j=32;j<64;j++)
  	 {
    	for(i=0;i<8;i++)
    	 {
      		LCD_Write(LCD_COMMAND,0x80+j-32);
      		LCD_Write(LCD_COMMAND,0x88+i);
      		LCD_Write(LCD_DATA,img[j*16+i*2]);
     	    LCD_Write(LCD_DATA,img[j*16+i*2+1]);
    	 }
  	 }
	LCD_GraphModeSet(0x01);//ͼʾ
}
void ST7920::LCD_ImgDisplay_from_flash(unsigned char *img)
{ 
	unsigned char *data = img;
	unsigned char i,j; 
	LCD_GraphModeSet(0x00); 

	for(i=0;i<32;i++)       
	{
		LCD_Write(LCD_COMMAND,0x80|i);  
		LCD_Write(LCD_COMMAND,0x80);    
		for(j=0;j<16;j++)          
		{                         
			LCD_Write(LCD_DATA,pgm_read_byte(data++)); 
		} 
	} 

	for(i=0;i<32;i++)              
	{ 
		LCD_Write(LCD_COMMAND,0x80|i);        
		LCD_Write(LCD_COMMAND,0x88);          
		for(j=0;j<16;j++)                
		{ 
			LCD_Write(LCD_DATA,pgm_read_byte(data++)); 
		} 
	}
	LCD_GraphModeSet(0x01);               
	LCD_Write(LCD_COMMAND,LCD_BASIC_FUNCTION); 
}
void ST7920::LCD_DisplayCLR(void)
{
  	unsigned char i,j;
    LCD_GraphModeSet(0x00); //ȹرͼʾ
	for(j=0;j<32;j++)
  	 {
    	for(i=0;i<8;i++)
     	 {
      		LCD_Write(LCD_COMMAND,0x80+j);		//趨ֱ
      		LCD_Write(LCD_COMMAND,0x80+i);		//趨ˮƽ
      	    LCD_Write(LCD_DATA,0x00);	//ݸֽ
      		LCD_Write(LCD_DATA,0x00);	//ݵֽ
    	 }
  	 }
  	for(j=32;j<64;j++)
  	 {
    	for(i=0;i<8;i++)
    	 {
      		LCD_Write(LCD_COMMAND,0x80+j-32);
      		LCD_Write(LCD_COMMAND,0x88+i);
      		LCD_Write(LCD_DATA,0x00);
     	    LCD_Write(LCD_DATA,0x00);
    	 }
  	 }
	LCD_GraphModeSet(0x01);//ͼʾ
}
//******************************************************************************
//*:void ST7920::LCD_ImgDisplayCharacter(unsigned char x,unsigned char y,unsigned char code *img) *
//*:ʹûͼķ,(x,y)һ16*16ͼ,Ҳַ		   *
//*ʽ:unsigned char x,unsigned char y,unsigned char code *img									   *
//*			xȡֵΧ:0~7													   *
//*			yȡֵΧ:0~31 (CM12864-12Һ)						       *
//*β˵:ˮƽλ,괹ֱλ,Ҫʾͼ							   *
//*Һ˵:															   *
//*      ________________128______________________              *
//*      |(0,0)                                    (7,0)|             *
//*      |                                              |             *
//*   64 |                                              |             *
//*    |(0,31)                                  (7,31)|             *
//*    |(8,0)                                   (15,0)|             *
//*    |                                              |             *
//*      |                                              |             *
//*      |(8,31)                                 (15,31)|             *
//*      |______________________________________________|             *
//*                                                                   *
//*ز:                                                              *
//*ʹ˵:˺CM12864-12Һ	                       		*
//******************************************************************************
void ST7920::LCD_ImgDisplayCharacter(unsigned char x,unsigned char y,unsigned char *img)
{
  	unsigned char i;
 	LCD_GraphModeSet(0x00);		//ȹرͼʾ
    LCD_Write(LCD_COMMAND,LCD_EXTEND_FUNCTION);
	for(i=0;i<16;i++)
  	 {
		LCD_GDRAM_AddressSet(0x80+y+i);
		LCD_GDRAM_AddressSet(0x80+x);
      	LCD_Write(LCD_DATA,img[i*2]);
      	LCD_Write(LCD_DATA,img[i*2+1]);
  	 }
   LCD_GraphModeSet(0x01);				//ͼʾ
}









